---
product: "AG Grid"
title: "Overlays & Loading"
description: "Display loading, empty and other grid states using overlays or loading rows."
framework: angular
version: "36.2.0"
related:
    - title: "Provided Overlays"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/overlays-provided/"
    - title: "Active Overlay"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/overlays-active/"
    - title: "Loading Rows"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/loading-rows/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Overlays & Loading

Use overlays to display messages over the grid, or loading rows to show placeholders while row data is loading.

## Loading

Set `loading=true` to display the loading overlay. With the Client-Side Row Model, also set `loadingRows=true` to display skeleton rows instead. See [Loading Rows](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/loading-rows/) for configuration and custom loading cells.

The Server-Side Row Model manages its loading rows as it requests data from the datasource. See [Server-Side Row Model Loading Rows](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/server-side-model-loading-rows/) for its full-width and skeleton loading options.

## Overlays

The grid automatically displays one of the provided overlays based on the current state of the grid. Custom overlays can be shown on demand by the application.

The following example shows the grid provided loading overlay when `loading=true`.

#### Loading overlay

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);

interface IAthlete {
  athlete: string;
  country: string;
}

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [loading]="true"
    [columnDefs]="columnDefs"
    [rowData]="rowData"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [{ field: "athlete" }, { field: "country" }];
  rowData!: IAthlete[];
}
```

[Live example: Loading overlay](https://www.ag-grid.com/archive/36.2.0/examples/overlays-overview/loading-overlay/angular/)

## Grid Provided Overlays

The grid provides the following overlays that will be shown automatically based on grid state (unless disabled):

- [Loading](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/overlays-provided/#loading) - shown when data is loading
- [No Rows](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/overlays-provided/#no-rows) - shown when there are no rows to display
- [No Matching Rows](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/overlays-provided/#no-matching-rows) - shown when no rows match the current filter
- [Exporting](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/overlays-provided/#exporting) - shown when data is exporting to CSV / Excel
- [File Input](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/overlays-provided/#file-input) - shown when `processFileInput` is provided and no row data is present

For details about the provided overlays and how to customise them see: [Provided Overlays](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/overlays-provided/).

## Active Overlay

Applications can provide a custom overlay and control when it is displayed. This enables full control over the content and timing of when the overlay is displayed.

For details about custom overlays see: [Active Overlay](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/overlays-active/).


---
product: "AG Grid"
title: "Overlays & Loading"
description: "Display loading, empty and other grid states using overlays or loading rows."
framework: vue
version: "36.2.0"
related:
    - title: "Provided Overlays"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/overlays-provided/"
    - title: "Active Overlay"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/overlays-active/"
    - title: "Loading Rows"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/loading-rows/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Overlays & Loading

Use overlays to display messages over the grid, or loading rows to show placeholders while row data is loading.

## Loading

Set `loading=true` to display the loading overlay. With the Client-Side Row Model, also set `loadingRows=true` to display skeleton rows instead. See [Loading Rows](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/loading-rows/) for configuration and custom loading cells.

The Server-Side Row Model manages its loading rows as it requests data from the datasource. See [Server-Side Row Model Loading Rows](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/server-side-model-loading-rows/) for its full-width and skeleton loading options.

## Overlays

The grid automatically displays one of the provided overlays based on the current state of the grid. Custom overlays can be shown on demand by the application.

The following example shows the grid provided loading overlay when `loading=true`.

#### Loading overlay

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);

interface IAthlete {
  athlete: string;
  country: string;
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :loading="true"
      :columnDefs="columnDefs"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IAthlete> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete" },
      { field: "country" },
    ]);
    const rowData = ref<IAthlete[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Loading overlay](https://www.ag-grid.com/archive/36.2.0/examples/overlays-overview/loading-overlay/vue3/)

## Grid Provided Overlays

The grid provides the following overlays that will be shown automatically based on grid state (unless disabled):

- [Loading](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/overlays-provided/#loading) - shown when data is loading
- [No Rows](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/overlays-provided/#no-rows) - shown when there are no rows to display
- [No Matching Rows](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/overlays-provided/#no-matching-rows) - shown when no rows match the current filter
- [Exporting](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/overlays-provided/#exporting) - shown when data is exporting to CSV / Excel
- [File Input](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/overlays-provided/#file-input) - shown when `processFileInput` is provided and no row data is present

For details about the provided overlays and how to customise them see: [Provided Overlays](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/overlays-provided/).

## Active Overlay

Applications can provide a custom overlay and control when it is displayed. This enables full control over the content and timing of when the overlay is displayed.

For details about custom overlays see: [Active Overlay](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/overlays-active/).


---
product: "AG Grid"
title: "Overlays & Loading"
description: "Display loading, empty and other grid states using overlays or loading rows."
framework: react
version: "36.2.0"
related:
    - title: "Provided Overlays"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/overlays-provided/"
    - title: "Active Overlay"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/overlays-active/"
    - title: "Loading Rows"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/loading-rows/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Overlays & Loading

Use overlays to display messages over the grid, or loading rows to show placeholders while row data is loading.

## Loading

Set `loading=true` to display the loading overlay. With the Client-Side Row Model, also set `loadingRows=true` to display skeleton rows instead. See [Loading Rows](https://www.ag-grid.com/archive/36.2.0/react-data-grid/loading-rows/) for configuration and custom loading cells.

The Server-Side Row Model manages its loading rows as it requests data from the datasource. See [Server-Side Row Model Loading Rows](https://www.ag-grid.com/archive/36.2.0/react-data-grid/server-side-model-loading-rows/) for its full-width and skeleton loading options.

## Overlays

The grid automatically displays one of the provided overlays based on the current state of the grid. Custom overlays can be shown on demand by the application.

The following example shows the grid provided loading overlay when `loading=true`.

#### Loading overlay

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [ClientSideRowModelModule];

interface IAthlete {
  athlete: string;
  country: string;
}

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete" },
    { field: "country" },
  ]);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IAthlete> loading={true} columnDefs={columnDefs} />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Loading overlay](https://www.ag-grid.com/archive/36.2.0/examples/overlays-overview/loading-overlay/reactFunctionalTs/)

## Grid Provided Overlays

The grid provides the following overlays that will be shown automatically based on grid state (unless disabled):

- [Loading](https://www.ag-grid.com/archive/36.2.0/react-data-grid/overlays-provided/#loading) - shown when data is loading
- [No Rows](https://www.ag-grid.com/archive/36.2.0/react-data-grid/overlays-provided/#no-rows) - shown when there are no rows to display
- [No Matching Rows](https://www.ag-grid.com/archive/36.2.0/react-data-grid/overlays-provided/#no-matching-rows) - shown when no rows match the current filter
- [Exporting](https://www.ag-grid.com/archive/36.2.0/react-data-grid/overlays-provided/#exporting) - shown when data is exporting to CSV / Excel
- [File Input](https://www.ag-grid.com/archive/36.2.0/react-data-grid/overlays-provided/#file-input) - shown when `processFileInput` is provided and no row data is present

For details about the provided overlays and how to customise them see: [Provided Overlays](https://www.ag-grid.com/archive/36.2.0/react-data-grid/overlays-provided/).

## Active Overlay

Applications can provide a custom overlay and control when it is displayed. This enables full control over the content and timing of when the overlay is displayed.

For details about custom overlays see: [Active Overlay](https://www.ag-grid.com/archive/36.2.0/react-data-grid/overlays-active/).
